<?php
/*************************************************************************
    NFO Real Sprite Shifter 2.0
    Copyright (C) 2007,2009,2010  Jasper Vries

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************/

//main shifting function
function shift_rel($nfo, $xpos, $ypos) {
	//add a newline to the end of the file
	//just in case the last line is a real sprite
	$nfo .= "\n";
	
	//define $xpos and $ypos as global vars
	$GLOBALS['xpos'] = $xpos;
	$GLOBALS['ypos'] = $ypos;
	
	
	//helper function to add pos values
	function add_rel($matches) {
		//use global $xpos and $ypos vars
		global $xpos, $ypos;
		
		//get current pos from preg pattern
		$old_xpos = $matches[2];
		$old_ypos = $matches[4];
		//calculate new pos
		$new_xpos = $old_xpos + $xpos;
		$new_ypos = $old_ypos + $ypos;
		
		//return new real sprite
		return $matches[1].$new_xpos.$matches[3].$new_ypos.$matches[5];
	}
	
	//pattern to match; explained below
	$pattern = "#(\s*-?\d+\s+.+\.(?:pcx|png)\s+)(\d+)(\s+)(\d+)(\s+\d+\s+\d+\s+\d+\s+-?\d+\s+-?\d+\s*\n)#";
	//            1                              2    3    4    5
	/*
	pattern:
	\s* --zero or more whitespace chars
	-?  --zero or one minus char
	\d+ --one or more decimal digit
	
	\s+ --one or more whitespace chars
	.+  --one or more chars
	\.pcx --.pcx
	
	\s+\d+ --(xpos) (one or more whitespace followed by one or more decimal digits
	\s+\d+ --(ypos)
	\s+\d+ --(compression)
	\s+\d+ --(ysize)
	\s+\d+ --(xsize)
	
	\s+-?\d+ --(xpos) (one or more whitespace followed by possible minus char and one or more dec digits
	\s+-?\d+ --(ypos) (one or more whitespace followed by possible minus char and one or more dec digits
	
	\s*\n --zero or more whitespace chars
	*/
	
	//return adjusted nfo
	return preg_replace_callback($pattern, "add_rel", $nfo);
	
}
?>